#include "descriptor/descriptor.h"

#define nparti 5

ITEM	moto[nparti];

void trasla_honda(double x,double y,double z);
void ruota_honda(int asse,int angolo);

int main(void) {

	
  ITEM	nero,vetro,bianco,legno,muro;
  ITEM	parabrezza,trazione_posteriore,trazione_anteriore,honda_resto,honda_nere;
  ITEM	mobiletto,quadro,parete;
  ITEM 	light,scene,camera;
  
  set_background(1,1,1,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(80,15,15,1,1,1,2,0, "point_light");
  
  /*** ATTRIBUTO Legno ***/
  legno = create_attribute("Legno");
  set_color(legno,0.55,0.24,0,0.7,0.7);
  set_reflectivity(legno,0.05,2);
  
  /*** ATTRIBUTO Muro ***/
  muro = create_attribute("Muro");
  set_color(muro,1,1,1,0.4,0.1);
  
  /*** ATTRIBUTE Nero ***/
  nero = create_attribute("Nero");
  set_color(nero,0,0,0,0.2,0.2);
  set_reflectivity(nero,0.05,2);

  /*** ATTRIBUTE Vetro ***/
  vetro = create_attribute("Vetro");
  set_color(vetro,0.68,0.86,1,0.5,0.5);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,1,1,1,1.2);
  
  /*** ATTRIBUTE Bianco ***/
  bianco = create_attribute("Bianco");
  set_color(bianco,1,1,1,0.6,0.2);
  set_reflectivity(bianco,0.1,2);
  
  // RUOTA POSTERIORE
  trazione_posteriore = read_obj("trazioneposteriore.obj","posteriore_obj");
  set_attribute(trazione_posteriore,nero);
  set_x_rotate (trazione_posteriore,45,1);
  set_translate(trazione_posteriore,0,0,0.969);

  // RUOTA ANTERIORE  
  trazione_anteriore = read_obj("trazioneanteriore.obj","anteriore_obj");
  set_attribute(trazione_anteriore,nero);
  set_x_rotate (trazione_anteriore,45,1);
  set_translate(trazione_anteriore,0,0,0.969);
  
  // PARTI DELLA CARENA
  honda_resto = read_obj("hondaresto.obj","honda_obj");
  set_domain_texture (honda_resto,bianco,"textures/tex_honda.hr",0,1,0,1,0,0.3,0.2);
  set_x_rotate (honda_resto,45,1);
  set_translate(honda_resto,0,0,0.969);
  
  // TUTTE LE ALTRE PARTI NERE
  honda_nere = read_obj("hondanere.obj","nero_obj");
  set_attribute(honda_nere,nero);
  set_x_rotate (honda_nere,45,1);
  set_translate(honda_nere,0,0,0.969);
  
  // PARABREZZA IN VETRO
  parabrezza = read_nurbs("parabrezzavetro.db");
  set_attribute (parabrezza,vetro);
  set_x_rotate (parabrezza,45,1);
  set_translate (parabrezza,0,0,0.969);
  
  parete = read_nurbs("parete.db");
  set_scale (parete,1,0.5,0.5);
  set_translate (parete,0,0.5,0.5);
  set_projection_texture(parete,muro,"textures/blown.hr",0,FALSE,0.5,0.3);
  set_scale (parete,1,70,70);
  set_translate (parete,-4.121,-40,-30);
  
  mobiletto = read_obj("mobiletto.obj","mobiletto_obj");
  set_scale (mobiletto,19,22,16);
  set_domain_texture (mobiletto,legno,"textures/wood.hr",0,1,0,1,0,0.3,0.2);
  set_translate (mobiletto,0,-3,-0.8);
  
  quadro = read_obj("quadro.obj","quadro_obj");
  set_z_rotate (quadro,90,1);
  set_scale (quadro,0.06,0.08,0.08);
  set_translate (quadro,1.5,-1.65,1.1);
  set_projection_texture(quadro,nero,"textures/pink.hr",2,FALSE,0.8,0.1);
  set_scale (quadro,3,2,2);
  set_z_rotate (quadro,90,1);
  set_y_rotate (quadro,80,1);
  set_translate (quadro,-5.653,-7.954,2.414);
  
  scene = create_list(mobiletto, "scene");
  scene = insert_in_list(scene,trazione_anteriore);
  scene = insert_in_list(scene,trazione_posteriore);
  scene = insert_in_list(scene,honda_resto);
  scene = insert_in_list(scene,honda_nere);
  scene = insert_in_list(scene,parabrezza);
  scene = insert_in_list(scene,parete);
  scene = insert_in_list(scene,quadro);
  
  moto[0]=trazione_anteriore;
  moto[1]=trazione_posteriore;
  moto[2]=honda_resto;
  moto[3]=honda_nere;
  moto[4]=parabrezza;
  
  int i;
  
  for (i=0;i<80;i++){
    // far cadere quadro,mettere a terra la moto e farla camminare un pò
	//set_camera("Camera",2,2,0,0.3,0.1,0.8,-0.4,-0.4,0.8,50,5);	funzione non implementata
	switch (i){
		/* CADUTA QUADRO */
		case 0:
			break;
		case 1:
			set_translate(quadro,3.278,7.954,-2.83);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-2.710,-7.954,2.76);
			break;
		case 2:
			set_translate(quadro,2.710,7.954,-2.76);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-2.244,-7.954,2.6);
			break;
		case 3:
			set_translate(quadro,2.244,7.954,-2.6);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-1.809,-7.954,2.225);
			break;
		case 4:
			set_translate(quadro,1.809,7.954,-2.225);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-1.406,-7.954,1.821);
			break;
		case 5:
			set_translate(quadro,1.406,7.954,-1.821);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-1.152,-7.954,1.421);
			break;
		case 6:
			set_translate(quadro,1.152,7.954,-1.421);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-0.904,-7.954,0.913);
			break;
		case 7:
			set_translate(quadro,0.904,7.954,-0.913);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-0.721,-7.954,0.414);
			break;
		case 8:
			set_translate(quadro,0.721,7.954,-0.414);
			set_y_rotate(quadro,-10,1);
			set_translate(quadro,-0.7,-7.954,-0.187);		
			break;
		case 9:
			set_translate(quadro,1,0,0);
			break;
		/* MOVIMENTO CAMERA */
		case 10:
		case 11:
		case 13:
		case 14:
		case 15:
			break;
		/* ROTAZIONE MOTO */
		case 16:
		case 17:
		case 18:
		case 19:
			ruota_honda(0,-9);
			trasla_honda(0,0,-0.19);
			break;
		
		case 20:
			ruota_honda(0,-9);
			trasla_honda(0,0,-0.15);
			break;
		/* MOVIMENTO CAMERA */
		case 21:
		case 22:
		case 23:
		case 24:
		case 25:
			break;
		/* ROTAZIONE RUOTA POSTERIORE */
		case 26:
		case 27:	
		case 28:
		case 29:
		case 30:
		case 31:
		case 32:
		case 33:
		case 34:
		case 35:
		case 36:
		case 37:
		case 38:
		case 39:
			set_translate(trazione_posteriore,-0.333,1.035,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,-1.035,0.179);
			break;
		/* MOVIMENTO CAMERA */
		case 40:
		case 41:
		case 42:
		case 43:
		case 44:
			break;
		/* MOVIMENTO MOTO IN AVANTI */
		case 45:
			set_translate(trazione_posteriore,-0.333,1.035,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,-0.835,0.179);
			set_translate(trazione_anteriore,-0.335,-2.120,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,2.320,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 46:
			set_translate(trazione_posteriore,-0.333,0.835,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,-0.635,0.179);
			set_translate(trazione_anteriore,-0.335,-2.320,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,2.520,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 47:
			set_translate(trazione_posteriore,-0.333,0.635,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,-0.435,0.179);
			set_translate(trazione_anteriore,-0.335,-2.520,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,2.720,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 48:
			set_translate(trazione_posteriore,-0.333,0.435,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,-0.235,0.179);
			set_translate(trazione_anteriore,-0.335,-2.720,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,2.920,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 49:
			set_translate(trazione_posteriore,-0.333,0.235,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,-0.035,0.179);
			set_translate(trazione_anteriore,-0.335,-2.920,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,3.120,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 50:
			set_translate(trazione_posteriore,-0.333,0.035,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,0.135,0.179);
			set_translate(trazione_anteriore,-0.335,-3.120,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,3.320,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 51:
			set_translate(trazione_posteriore,-0.333,-0.135,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,0.335,0.179);
			set_translate(trazione_anteriore,-0.335,-3.320,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,3.520,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 52:
			set_translate(trazione_posteriore,-0.333,-0.335,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,0.535,0.179);
			set_translate(trazione_anteriore,-0.335,-3.520,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,3.720,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 53:
			set_translate(trazione_posteriore,-0.333,-0.535,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,0.735,0.179);
			set_translate(trazione_anteriore,-0.335,-3.720,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,3.920,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 54:
			set_translate(trazione_posteriore,-0.333,-0.735,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,0.935,0.179);
			set_translate(trazione_anteriore,-0.335,-3.920,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,4.120,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 55:
			set_translate(trazione_posteriore,-0.333,-0.935,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,1.135,0.179);
			set_translate(trazione_anteriore,-0.335,-4.120,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,4.320,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 56:
			set_translate(trazione_posteriore,-0.333,-1.135,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,1.335,0.179);
			set_translate(trazione_anteriore,-0.335,-4.320,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,4.520,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 57:
			set_translate(trazione_posteriore,-0.333,-1.335,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,1.535,0.179);
			set_translate(trazione_anteriore,-0.335,-4.520,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,4.720,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 58:
			set_translate(trazione_posteriore,-0.333,-1.535,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,1.735,0.179);
			set_translate(trazione_anteriore,-0.335,-4.720,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,4.920,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 59:
			set_translate(trazione_posteriore,-0.333,-1.735,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,1.935,0.179);
			set_translate(trazione_anteriore,-0.335,-4.920,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,5.120,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 60:
			set_translate(trazione_posteriore,-0.333,-1.935,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,2.135,0.179);
			set_translate(trazione_anteriore,-0.335,-5.120,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,5.320,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 61:
			set_translate(trazione_posteriore,-0.333,-2.135,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,2.335,0.179);
			set_translate(trazione_anteriore,-0.335,-5.320,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,5.520,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 62:
			set_translate(trazione_posteriore,-0.333,-2.335,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,2.535,0.179);
			set_translate(trazione_anteriore,-0.335,-5.520,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,5.720,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 63:
			set_translate(trazione_posteriore,-0.333,-2.535,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,2.735,0.179);
			set_translate(trazione_anteriore,-0.335,-5.720,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,5.920,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 64:
			set_translate(trazione_posteriore,-0.333,-2.735,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,2.935,0.179);
			set_translate(trazione_anteriore,-0.335,-5.920,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,6.120,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 65:
			set_translate(trazione_posteriore,-0.333,-2.935,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,3.135,0.179);
			set_translate(trazione_anteriore,-0.335,-6.120,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,6.320,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 66:
			set_translate(trazione_posteriore,-0.333,-3.135,-0.179);
			set_x_rotate(trazione_posteriore,-9,1);
			set_translate(trazione_posteriore,0.333,3.335,0.179);
			set_translate(trazione_anteriore,-0.335,-6.320,-0.102);
			set_x_rotate(trazione_anteriore,-9,1);
			set_translate(trazione_anteriore,0.335,6.520,0.102);
			set_translate(honda_resto,0,0.2,0);
			set_translate(honda_nere,0,0.2,0);
			set_translate(parabrezza,0,0.2,0);	
			break;
		case 67:
			set_translate(trazione_posteriore,-0.333,-3.335,-0.179);
			set_x_rotate(trazione_posteriore,-4,1);
			set_translate(trazione_posteriore,0.333,3.415,0.179);
			set_translate(trazione_anteriore,-0.335,-6.520,-0.102);
			set_x_rotate(trazione_anteriore,-4,1);
			set_translate(trazione_anteriore,0.335,6.600,0.102);
			set_translate(honda_resto,0,0.08,0);
			set_translate(honda_nere,0,0.08,0);
			set_translate(parabrezza,0,0.08,0);	
			break;
		case 68:
			set_translate(trazione_posteriore,-0.333,-3.415,-0.179);
			set_x_rotate(trazione_posteriore,9,1);
			set_translate(trazione_posteriore,0.333,3.215,0.179);
			set_translate(trazione_anteriore,-0.335,-6.600,-0.102);
			set_x_rotate(trazione_anteriore,9,1);
			set_translate(trazione_anteriore,0.335,6.400,0.102);
			set_translate(honda_resto,0,-0.2,0);
			set_translate(honda_nere,0,-0.2,0);
			set_translate(parabrezza,0,-0.2,0);	
			break;
		/* CADUTA MOTO */
		case 69:
			ruota_honda(1,10);
			trasla_honda(0.05,0,0.04);
			break;
		case 70:
			ruota_honda(1,10);
			trasla_honda(0.05,0,0.04);
			break;
		case 71:
			ruota_honda(1,10);
			trasla_honda(0.07,0,0.05);
			break;
		case 72:
			ruota_honda(1,10);
			trasla_honda(0.08,0,0.05);
			break;
		case 73:
			ruota_honda(1,10);
			trasla_honda(0.08,0,0.07);
			break;
		case 74:
			ruota_honda(1,10);
			trasla_honda(0.07,0,0.07);
			break;
		case 75:
			ruota_honda(1,10);
			trasla_honda(0.05,0,0.14);
			break;
		case 76:
			ruota_honda(1,10);
			trasla_honda(0,0,0.2);
			break;
		case 77:
			ruota_honda(1,10);
			trasla_honda(0,0,0.21);
			break;
		case 78:
			ruota_honda(1,-5);
			trasla_honda(0,0,-0.1);
			break;
		case 79:
			/*set_y_rotate(trazione_posteriore,10,1);
			set_y_rotate(trazione_anteriore,10,1);
			set_y_rotate(honda_resto,10,1);
			set_y_rotate(honda_nere,10,1);
			set_y_rotate(parabrezza,10,1);
			set_translate(trazione_posteriore,0,0,0.26);
			set_translate(trazione_anteriore,0,0,0.26);
			set_translate(honda_resto,0,0,0.26);
			set_translate(honda_nere,0,0,0.26);
			set_translate(parabrezza,0,0,0.26);*/
			ruota_honda(1,10);
			trasla_honda(0,0,0.26);
			break;
		}
		
    save_scene_ani(79,"honda_animazione.ani","honda_animazione","animazione_honda",scene);
	}
   return(0);
}

  

  void trasla_honda (double x,double y,double z){
	  int i;
	  for (i=0;i<nparti;i++)
		  set_translate(moto[i],x,y,z);
	  }
  
  void ruota_honda(int asse,int angolo){
	  int i;
	  switch(asse){
		  case 0:
			for (i=0;i<nparti;i++)
				set_x_rotate(moto[i],angolo,1);  
			break;
		case 1:				
			for (i=0;i<nparti;i++)
				set_y_rotate(moto[i],angolo,1);
			break;
		case 2:
			for (i=0;i<nparti;i++)
				set_z_rotate(moto[i],angolo,1);
			break;
		}
	}

