#include "descriptor/descriptor.h"

int main(void) {

  ITEM	metallo,grigio,arancio,nero,blu,ottone,vetro,bianco,legno,muro;
  ITEM	parti_metallo,parti_grigie,parti_arancio,parti_nere,parti_blu,parti_ottone;
  ITEM	parabrezza,parabrezza_resto,posteriore,posteriore_sopra,parti_tricolore,parti_tricoloreR,parti_tricoloreL;
  ITEM	mobiletto,quadro,parete;
  ITEM 	scene;
  
  set_background(1,1,1,TRUE);
  set_ambient_light(1,1,1,0.7);
  create_point_light(130,20,15,1,1,1,2,0, "point_light");
  
  /*** ATTRIBUTO Legno ***/
  legno = create_attribute("Legno");
  set_color(legno,0.55,0.24,0,0.7,0.7);
  set_reflectivity(legno,0.04,2);
  
  /*** ATTRIBUTO Muro ***/
  muro = create_attribute("Muro");
  set_color(muro,1,1,1,0.4,0.1);
  
  /*** ATTRIBUTO Blu ***/
  blu = create_attribute("Blu");
  set_color(blu,0,0,0.13,0.3,0.2);
  set_reflectivity(blu,0.1,2);
  
  /*** ATTRIBUTO Arancio ***/
  arancio = create_attribute("Arancio");
  set_color(arancio,1,0.46,0,0.3,0.2);
  set_reflectivity(arancio,0.1,2);

  /*** ATTRIBUTE Nero ***/
  nero = create_attribute("Nero");
  set_color(nero,0,0,0,0.2,0.2);
  set_reflectivity(nero,0.05,2);

  /*** ATTRIBUTE Grigio ***/
  grigio = create_attribute("Grigio");
  set_color(grigio,0.6,0.61,0.66,0.31,0.25);
  
  /*** ATTRIBUTE Vetro ***/
  vetro = create_attribute("Vetro");
  set_color(vetro,0.68,0.86,1,0.5,0.5);
  set_reflectivity(vetro,0.24,2);
  set_transparency(vetro,1,1,1,1.2);
  
  /*** ATTRIBUTE Metallo ***/
  metallo = create_attribute("Metallo");
  set_color(metallo,0.84,0.77,0.65,0.4,0.6);
  set_reflectivity(metallo,0.3,2);
  
  /*** ATTRIBUTE Ottone ***/
  ottone = create_attribute("Ottone");
  set_color(ottone,0.66,0.62,0.35,0.4,0.67);
  set_reflectivity(ottone,0.4,2);
  
  /*** ATTRIBUTE Bianco ***/
  bianco = create_attribute("Bianco");
  set_color(bianco,1,1,1,0.6,0.2);
  set_reflectivity(bianco,0.1,2);
  
  parti_blu = read_obj("partiblu.obj", "blu_obj");
  //set_attribute (parti_blu,blu);
  set_projection_texture(parti_blu,blu,"textures/blu.hr",0,TRUE,0.3,0.2);
  set_x_rotate (parti_blu,45,1);
  set_translate (parti_blu,0,0,0.969);
  
  parti_arancio = read_obj("partiarancio.obj", "arancio_obj");
  //set_attribute (parti_arancio,arancio);
  set_projection_texture(parti_arancio,arancio,"textures/arancio.hr",0,TRUE,0.3,0.2);
  set_x_rotate (parti_arancio,45,1);
  set_translate (parti_arancio,0,0,0.969);
  
  parti_metallo = read_obj("partimetallo.obj", "metallo_obj");
  //set_attribute (parti_metallo,metallo);
  set_projection_texture(parti_metallo,metallo,"textures/metallo.hr",0,TRUE,0.3,0.2);
  set_x_rotate (parti_metallo,45,1);
  set_translate (parti_metallo,0,0,0.969);
  
  parti_tricoloreR = read_obj("partitricoloreR.obj", "tricoloreR_obj");
  set_z_rotate (parti_tricoloreR,180,1);
  set_x_rotate (parti_tricoloreR,-100,1);
  set_translate (parti_tricoloreR,1,-1.2,-0.75);
  set_projection_texture(parti_tricoloreR,arancio,"textures/repsol.hr",0,FALSE,0.3,0.2);
  set_translate (parti_tricoloreR,-1,1.2,0.75);
  set_x_rotate (parti_tricoloreR,100,1);
  set_z_rotate (parti_tricoloreR,-180,1);
  set_x_rotate (parti_tricoloreR,45,1);
  set_translate (parti_tricoloreR,0,0,0.969);
  
  parti_tricoloreL = read_obj("partitricoloreL.obj", "tricoloreL_obj");
  set_x_rotate (parti_tricoloreL,-80,1);
  set_translate (parti_tricoloreL,0.8,-1.1,0.78);
  set_projection_texture (parti_tricoloreL,arancio,"textures/repsol.hr",0,FALSE,0.3,0.2);
  set_translate (parti_tricoloreL,-0.8,1.1,-0.78);
  set_x_rotate (parti_tricoloreL,80,1);
  set_x_rotate (parti_tricoloreL,45,1);
  set_translate (parti_tricoloreL,0,0,0.969);
  
  parti_grigie = read_obj("partigrigie.obj", "grigio_obj");
  set_attribute (parti_grigie,grigio);
  set_x_rotate (parti_grigie,45,1);
  set_translate (parti_grigie,0,0,0.969);
  
  parti_ottone = read_obj("partiottone.obj", "ottone_obj");
  //set_attribute (parti_ottone,ottone);
  set_projection_texture(parti_ottone,ottone,"textures/bronzo2.hr",0,TRUE,0.3,0.2);
  set_x_rotate (parti_ottone,45,1);
  set_translate (parti_ottone,0,0,0.969);
  
  parti_nere = read_obj("partinere.obj", "nero_obj");
  set_attribute (parti_nere,nero);
  set_x_rotate (parti_nere,45,1);
  set_translate (parti_nere,0,0,0.969);
  
  parabrezza = read_nurbs("parabrezzavetro.db");
  set_attribute (parabrezza,vetro);
  set_x_rotate (parabrezza,45,1);
  set_translate (parabrezza,0,0,0.969);
  
  parabrezza_resto = read_nurbs ("parabrezza.dbe");
  set_scale (parabrezza_resto,1.8,1.8,1.8);
  set_x_rotate (parabrezza_resto,45,1);
  set_z_rotate (parabrezza_resto,180,1);
  set_translate (parabrezza_resto,0.6,0.37,-3.5);
  set_projection_texture (parabrezza_resto,arancio,"textures/46.hr",2,TRUE,0.3,0.2);
  set_translate (parabrezza_resto,-0.6,-0.37,3.5);
  set_z_rotate (parabrezza_resto,-180,1);
  set_x_rotate (parabrezza_resto,-45,1);
  set_scale (parabrezza_resto,1/1.8,1/1.8,1/1.8);
  set_x_rotate (parabrezza_resto,45,1);
  set_translate (parabrezza_resto,0,0,0.969);
  
  posteriore = read_nurbs ("posterioresotto.dbe");
  set_scale (posteriore,1.8,1.8,1.8);
  set_y_rotate (posteriore,180,1);
  set_z_rotate (posteriore,-90,1);
  set_translate (posteriore,2.5,-0.75,3);
  set_projection_texture (posteriore,arancio,"textures/repsol.hr",2,FALSE,0.3,0.2);
  set_translate (posteriore,-2.5,0.75,-3);
  set_z_rotate (posteriore,90,1);
  set_y_rotate (posteriore,-180,1);
  set_scale (posteriore,1/1.8,1/1.8,1/1.8);
  set_x_rotate (posteriore,45,1);
  set_translate (posteriore,0,0,0.969);
  
  posteriore_sopra = read_nurbs ("posterioresopra.db");
  set_scale (posteriore_sopra,2,2,2);
  set_z_rotate (posteriore_sopra,-90,1);
  set_translate (posteriore_sopra,2.82,0.612,-2.954);
  set_projection_texture (posteriore_sopra,blu,"textures/46.hr",2,FALSE,0.3,0.2);
  set_translate (posteriore_sopra,-2.82,-0.612,2.954);
  set_z_rotate (posteriore_sopra,90,1);
  set_scale (posteriore_sopra,0.5,0.5,0.5);
  set_x_rotate (posteriore_sopra,45,1);
  set_translate (posteriore_sopra,0,0,0.969);
  
  parete = read_nurbs("parete.db");
  set_scale (parete,1,0.5,0.5);
  set_translate (parete,0,0.5,0.5);
  set_projection_texture(parete,muro,"textures/blown.hr",0,FALSE,0.5,0.3);
  set_scale (parete,1,100,100);
  set_translate (parete,-4.121,-50,-50);
  
  mobiletto = read_obj("mobiletto.obj","mobiletto_obj");
  set_scale (mobiletto,19,22,16);
  set_domain_texture (mobiletto,legno,"textures/wood.hr",0,1,0,1,0,0.3,0.2);
  set_translate (mobiletto,0,-3,-0.8);
  
  quadro = read_obj("quadro.obj","quadro_obj");
  set_z_rotate (quadro,90,1);
  set_scale (quadro,0.06,0.08,0.08);
  set_translate (quadro,1.5,-1.65,1.1);
  
  set_projection_texture(quadro,nero,"textures/pink.hr",2,FALSE,0.3,0.2);
  set_scale (quadro,3,2,2);
  set_z_rotate (quadro,90,1);
  set_y_rotate (quadro,80,1);
  set_translate (quadro,-5.653,-7.954,2.414);
  scene = create_list(parabrezza, "scene");
  scene = insert_in_list(scene,posteriore);
  scene = insert_in_list(scene,posteriore_sopra);
  scene = insert_in_list(scene,parabrezza_resto);
  scene = insert_in_list(scene,parti_tricoloreR);
  scene = insert_in_list(scene,parti_tricoloreL);
  scene = insert_in_list(scene,parti_arancio);
  scene = insert_in_list(scene,parti_blu);
  scene = insert_in_list(scene,parti_metallo);
  scene = insert_in_list(scene,parti_ottone);
  scene = insert_in_list(scene,parti_grigie);
  scene = insert_in_list(scene,parti_nere);
  scene = insert_in_list(scene,parete);
  scene = insert_in_list(scene,mobiletto);
  scene = insert_in_list(scene,quadro);
  
  save_scene("honda.md","scene_honda",scene);
  return(0);
}
